angular.module('khlm.services', ['khlm.conf'])

.factory('feedmanager', function($localstorage, $translate, appvars) {
  var feeds = {
    notices: {
      title: 'Notices',
      feed: 'https://portaal.khleuven.be/rss.php'
    },
    internat: {
      title: 'International news',
      feed: 'https://internat.khleuven.be/?q=rss.xml'
    },
    projectwork: {
      title: 'Project work news',
      feed: 'https://projectwerk.khleuven.be/news.atom'
    },
    custom: []
  };
  
  var icals = {
    coursecal: {
      title: 'Course calendar',
      feed: ''
    },
    custom: []
  };
  
  // Updated callback functions
  var updatedCBFuncs = [];
  
  return {
    getFeeds: function getFeeds() {return feeds;},
    getIcals: function getIcals() {return icals;},
    updateUrls: function updateUrls() {
      // Set feed data from saved local storage
      var url_notices = $localstorage.get('url_notices', false);
      var url_internat = $localstorage.get('url_internat', false);
      var url_projectwork = $localstorage.get('url_projectwork', false);
      var url_coursecal = $localstorage.get('url_coursecal', false);
      var url_backend = $localstorage.get('url_backend', false);
      if (url_notices !== false)
        feeds.notices.feed = url_notices;
      if (url_internat !== false)
        feeds.internat.feed = url_internat;
      if (url_projectwork !== false)
        feeds.projectwork.feed = url_projectwork
      if (url_coursecal !== false)
        icals.coursecal.feed = url_coursecal;
      if (url_backend !== false)
        appvars.url_backend = url_backend;
            
      // Set custom URLs from saved local storage
      var customFeeds = $localstorage.getObject('custom_feeds');
      if (customFeeds.length)
        feeds.custom = customFeeds;
      var customCals = $localstorage.getObject('custom_cals');
      if (customCals.length)
        icals.custom = customCals;
      
      // Callbacks
      for (var i in updatedCBFuncs) {
        updatedCBFuncs[i]();
      }
    },
    onUpdatedUrls: function onUpdatedUrls(fn) {
      if (typeof fn === 'function')
        updatedCBFuncs.push(fn);
    },
    updateTranslations: function(fn) {
      $translate([
        "Notices",
        "International news",
        "Project work news",
        "Course calendar"
      ]).then(function(tr) {
        feeds.notices.title = tr['Notices'];
        feeds.internat.title = tr['International news'];
        feeds.projectwork.title = tr['Project work news'];
        icals.coursecal.title = tr['Course calendar'];
        if (typeof fn === 'function')
          fn();
      });
    }
  };
})

;